POJ3186 Treats for the Cows(区间dp)

Treats for the Cows
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 7271 Accepted: 3844

Description

FJ has purchased N (1 <= N <= 2000) yummy treats for the cows who get money for giving vast amounts of milk. FJ sells one treat per day and wants to maximize the money he receives over a given period time. 

The treats are interesting for many reasons:
  • The treats are numbered 1..N and stored sequentially in single file in a long box that is open at both ends. On any day, FJ can retrieve one treat from either end of his stash of treats.
  • Like fine wines and delicious cheeses, the treats improve with age and command greater prices.
  • The treats are not uniform: some are better and have higher intrinsic value. Treat i has value v(i) (1 <= v(i) <= 1000).
  • Cows pay more for treats that have aged longer: a cow will pay v(i)*a for a treat of age a.
Given the values v(i) of each of the treats lined up in order of the index i in their box, what is the greatest value FJ can receive for them if he orders their sale optimally? 

The first treat is sold on day 1 and has age a=1. Each subsequent day increases the age by 1.

Input

Line 1: A single integer, N 

Lines 2..N+1: Line i+1 contains the value of treat v(i)

Output

Line 1: The maximum revenue FJ can achieve by selling the treats

Sample Input

5
1
3
1
5
2

Sample Output

43

Hint

Explanation of the sample: 

Five treats. On the first day FJ can sell either treat #1 (value 1) or treat #5 (value 2). 

FJ sells the treats (values 1, 3, 1, 5, 2) in the following order of indices: 1, 5, 2, 3, 4, making 1x1 + 2x2 + 3x3 + 4x1 + 5x5 = 43.

Source

USACO 2006 February Gold & Silver

题意:给出的一系列的数字,可以看成一个双向队列,每次只能从队首或者队尾出队,第n个出队就拿这个数乘以n,最后将和加起来,求最大和。

思路:一开始想这难道不是贪心?从头部或者尾部取较大的数计算不就行了?然后找到了一组反例

4 101 1 102 100  这几个数如果按照贪心是 4 100 101 1 102但比4 101 1 100 102小,所以贪心不可行,正解是dp。

那么有两种dp的思路,先介绍第一种

dp[i][j]表示左边取i个数,右边取j个数可以达到的最大值

然后这个状态可以由dp[i-1][j]和dp[i][j-1]转移过来

项目的初态是dp[0][1~n]和dp[1~n][0]单独计算即可。

然后就是下标处理的时候要小心一点就可以了。

#include <iostream>
#include <algorithm>
const int maxN = 2e3 + 10;
int dp[maxN][maxN];
int v[maxN];
using namespace std;
int main()
{
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> v[i];
	for (int i = 1; i < n; i++)
		dp[0][i] = dp[0][i - 1] + i * v[n - i];
	for (int i = 1; i < n; i++)
		dp[i][0] = dp[i - 1][0] + i * v[i - 1];
	for (int i = 1; i < n; i++)
		for (int j = 1; i + j <= n; j++)
			dp[i][j] = max(dp[i - 1][j] + (i + j) * v[i - 1], dp[i][j - 1] + (i + j) * v[n - j]);
	int ans = -1;
	for (int i = 0; i <= n; i++)
		ans = max(ans, dp[i][n - i]);
	cout << ans << endl;

}

法2:区间dp。dp[i][j]表示下标从i-j组成的字串可以达到的最大值

那么这个状态可以有dp[i+1][j]和dp[i][j-1]转移而来,注意转移的方向⚠️

可以画一个图发现需要i从n-1到0,j从i到n-1(注意j要大于等于i

初始状态是dp[i][i] = a[i]

然后就可以了,其实也没几行代码。

#include <iostream>
#include <algorithm>
const int maxn = 2010;
int a[maxn];
int dp[maxn][maxn];//dp[i][j]表示下标为i-j的区间子串的最大值
using namespace std;
int n;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    for(int i = 0; i < n; i++)
    {
        cin>>a[i];
        dp[i][i] = a[i];
    }
    for(int i = n - 1; i >= 0; i--)
        for(int j = i; j < n; j++)
            dp[i][j] = max(dp[i + 1][j] + a[i] * (n - j + i), dp[i][j - 1] + a[j] * (n - j + i));
    cout<<dp[0][n-1]<<endl;
    return 0;
    
}

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值